'\"
.\"
.\" .DE
.\"	End of indented unfilled display.
.\"
.\" .SO ?manpage?
.\"	Start of list of standard options for a Tk widget. The manpage
.\"	argument defines where to look up the standard options; if
.\"	omitted, defaults to "options". The options follow on successive
.\"	lines, in three columns separated by tabs.
.\"
.\" .SE
.\"	End of list of standard options for a Tk widget.
.\"
.\" .OP cmdName dbName dbClass
.\"	Start of description of a specific option.  cmdName gives the
.\"	option's name as specified in the class command, dbName gives
.\"	the option's name in the option database, and dbClass gives
.\"	the option's class in the option database.
.\"
.\" .UL arg1 arg2
.\"	Print arg1 underlined, then print arg2 normally.
.\"
.\" .QW arg1 ?arg2?
.\"	Print arg1 in quotes, then arg2 normally (for trailing punctuation).
.\"
.\" .PQ arg1 ?arg2?
.\"	Print an open parenthesis, arg1 in quotes, then arg2 normally
.\"	(for trailing punctuation) and then a closing parenthesis.
.\"
.\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
.\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ta \\n()Au \\n()Bu
.ie !"\\$3"" \{\
\&\\$1 \\fI\\$2\\fP (\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
.\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
.AS Tcl_Interp Tcl_CreateInterp in/out
.\"	# BS - start boxed text
.\"	# ^y = starting y location
.\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
.\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
.\"	# VS - start vertical sidebar
.\"	# ^Y = starting y location
.\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.if !"\\$2"" .br
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
.\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
.\"	# Special macro to handle page bottom:  finish off current
.\"	# box/sidebar if in box/sidebar mode, then invoked standard
.\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
.\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
.\"	# DE - end display
.de DE
.fi
.RE
.sp
..
.\"	# SO - start of list of standard options
.de SO
'ie '\\$1'' .ds So \\fBoptions\\fR
'el .ds So \\fB\\$1\\fR
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 5.5c 11c
.ft B
..
.\"	# SE - end of list of standard options
.de SE
.fi
.ft R
.LP
See the \\*(So manual entry for details on the standard options.
..
.\"	# OP - start of full description for a single option
.de OP
.LP
.nf
.ta 4c
Command-Line Name:	\\fB\\$1\\fR
Database Name:	\\fB\\$2\\fR
Database Class:	\\fB\\$3\\fR
.fi
.IP
..
.\"	# CS - begin code excerpt
.de CS
.RS
.nf
.ta .25i .5i .75i 1i
..
.\"	# CE - end code excerpt
.de CE
.fi
.RE
..
.\"	# UL - underline word
.de UL
\\$1\l'|0\(ul'\\$2
..
.\"	# QW - apply quotation marks to word
.de QW
.ie '\\*(lq'"' ``\\$1''\\$2
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\$2
..
.\"	# PQ - apply parens and quotation marks to word
.de PQ
.ie '\\*(lq'"' (``\\$1''\\$2)\\$3
.\"" fix emacs highlighting
.el (\\*(lq\\$1\\*(rq\\$2)\\$3
..
.\"	# QR - quoted range
.de QR
.ie '\\*(lq'"' ``\\$1''\\-``\\$2''\\$3
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\-\\*(lq\\$2\\*(rq\\$3
..
.\"	# MT - "empty" string
.de MT
.QW ""
..
.TH scintilla n 0.25 Tk "ScintillaTK Text Widget"
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
scintilla \- Scintilla text widget
.SH SYNOPSIS
\fBpackage require scintillatk\fR ?\fB0.25\fR?
.sp
\fBscintilla\fR \fIpathName \fR?\fIoptions\fR?
.SO
\-autoseparators	\-highlight	\-moveupdatecommand
\-background	\-highlightthickness	\-relief
\-blink	\-highlightbackground	\-showws
\-borderwidth	\-language	\-state
\-busycursor	\-linesaddedcommand	\-tabwidth
\-cursor	\-marginbackground	\-takefocus
\-foldstyle	\-marginbg	\-xscrollcommand
\-font	\-marginforeground	\-yscrollcommand
\-foreground	\-marginfg	\-undo
\-height	\-marginwidthcommand	\-width
.SE
.SH "WIDGET-SPECIFIC OPTIONS"
.OP \-autoseparators autoSeparators AutoSeparators
Specifies a boolean that says whether separators are automatically
inserted in the undo stack. Only meaningful when the \fB\-undo\fR
option is true.
.OP \-height height Height
Specifies the desired height for the window, in units of characters
in the font given by the \fB\-font\fR option.
Must be at least one.
.OP \-state state State
Specifies one of two states for the text:  \fBnormal\fR or \fBdisabled\fR.
If the text is disabled then characters may not be inserted or deleted
and no insertion cursor will be displayed, even if the input focus is
in the widget.
.OP \-width width Width
Specifies the desired width for the window in units of characters
in the font given by the \fB\-font\fR option.
If the font does not have a uniform width then the width of the character
.QW 0
is used in translating from character units to screen units.
.OP \-busycursor cursor Cursor
Cursor to display when text widget is computationally busy.
.OP \-foldstyle foldstyle FoldStyle
See Scintilla documentation for style values.
.OP \-language language Language
Specifies which programming language lexer to use for syntax highlighting.
.OP \-linesaddedcommand lindesAddedCommand LinesAddedCommand
Callback command when new lines are inserted in the document.  This function can be used to update margin indicators if necessary.
.OP \-marginbackground marginBackground MarginBackground
The backgound color of the margin columns.
.OP \-marginforeground marginForeground MarginForeground
The foregound (font) color of the margin columns.
.OP \-marginwidthcommand 
Callback command used when margin width changes.
.OP \-moveupdatecommand moveUpdateCommand MoveUpdateCommand
Callback command when margin changes.
.OP \-showws showws ShowWs
Show the ws???

.BE
.SH DESCRIPTION
.PP
The \fBscintilla\fR command creates a new window (given by the \fIpathName\fR arg) and makes it into a Scintilla text widget. Additional options, described above, may be specified on the command line or in the option database to configure aspects of the text such as its default background color and relief.  The \fBtext\fR command returns the path name of the new window.
.PP
.SH "WIDGET COMMAND"
.PP
.TP
\fIpathName \fBannotate \fIoption ?arg arg ...?\fR
Text annotations are separate strings that can be assigned to the lines within the document. The annotation is displayed without any line numbers and appears in extra space which is created by the widget for its display. There are various options available:
.RS
.TP
\fBclearall\fR
removes annotation strings for all lines
.TP
\fBget \fIline\fR
Returns the annotation text for the specified line.
.TP
\fBset \fIline text ?tagName text tagName ...?\fR
Assigns the specified text string to the specified line. If no tagName option is specified, the annotation text will use the default text styling. If a single tagName option is used it will control the appearance for all of the annotation text. By using multiple text and tagName options it's possible to have different appearances for different subranges of the text.
.TP
\fBshow \fI0|1|2\fR
Used to control the display of annotations where 0 - hiding, 1 - showing or 2 - showing with a bounding box. Note, this affects all lines with annotations.
.RE
.TP
\fIpathName \fBbbox \fIindex\fR
Returns a list of four elements describing the screen area of the character given by index. The first two elements of the list give the x and y coordinates of the upper\-left corner of the area occupied by the character, and the last two elements give the width and height of the area. If the character is not visible on the screen then the return value is an empty list.
.TP
\fIpathName \fBcget \fIoption\fR
Returns the current value of the configuration option given by option. Option may have any of the values accepted by the scintilla command.
.TP
\fIpathName \fBcompare \fIindex1 op index2\fR
Compares the indices given by index1 and index2 according to the relational operator given by op, and returns 1 if the relationship is satisfied and 0 if it is not. Op must be one of the operators <, <=, =, >, >, or !. If op is == then 1 is returned if the two indices refer to the same character, if op is < then 1 is returned if index1 refers to an earlier character in the text than index2, and so on.
.TP
\fIpathName \fBconfigure \fI?option? ?value option value ...?\fR
Query or modify the configuration options of the widget. If no option is specified, returns a list describing all of the available options for pathName. If option is specified with no value, then the command returns a list describing the one named option (this list will be identical to the corresponding sublist of the value returned if no option is specified). If one or more option\-value pairs are specified, then the command modifies the given widget option(s) to have the given value(s); in this case the command returns an empty string. Option may have any of the values accepted by the scintilla command.
.TP
\fIpathName \fBcount \fI?options? index1 index2\fR
Counts the number of relevant things between the two indices. If index1 is after index2, the result will be a negative number (and this holds for each of the possible options). The actual items which are counted depend on the options given. The result is a list of integers, one for the result of each counting option given. Valid counting options are \-chars, \-displaylines and \-lines. The default value, if no option is specified, is \-chars. The count options are interpreted as follows:
.RS
.IP \fB\-chars\fR
count all characters, whether elided or not. Do not count embedded windows or images.
.IP \fB\-displaylines\fR
count all display lines (i.e. ignore lines which are folded) from the line of the first index up to, but not including the display line of the second index. Therefore if they are both on the same display line, zero will be returned. By definition displaylines are visible and therefore this only counts portions of actual visible lines.
.IP \fB\-lines\fR
count all lines (irrespective of folding) from the line of the first index up to, but not including the line of the second index. Therefore if they are both on the same line, zero will be returned. Lines are counted whether they are currently visible (non\-folded) or not.
.RE
.TP
\fIpathName \fBdelete \fIindex1 ?index2?\fR
Delete a range of characters from the text. If both index1 and index2 are specified, then delete all the characters starting with the one given by index1 and stopping just before index2 (i.e. the character at index2 is not deleted). If index2 doesn't specify a position later in the text than index1 then no characters are deleted. If index2 isn't specified then the single character at index1 is deleted. It is not allowable to delete characters in a way that would leave the text without a newline as the last character. The command returns an empty string.
.TP
\fIpathName \fBdump \fI?switches? index1 ?index2?_\fR
Return the contents of the text widget from index1 up to, but not including index2, including the text and information about marks, tags, and embedded windows. If index2 is not specified, then it defaults to one character past index1. The information is returned in the following format::
key1 value1 index1 key2 value2 index2 ...
The possible key values are indicatoron, indicatoroff, text, mark, styleon, styleoff, tagon, tagoff, image, and window. The corresponding value is the indicator type, text, mark name, style number, tag name, image name, or window name. The index information is the index of the start of the indicator transition, style transition, text, mark, tag transition, image or window. The image and window options are not supported and will return nothing. One or more of the following switches (or abbreviations thereof) may be specified to control the dump:
.RS
.IP \fB\-all\fR
Return information about all elements: indicator, style, text, marks, tags, images and windows. This is the default.
.TP
\fB\-command \fIcommand\fR
Instead of returning the information as the result of the dump operation, invoke the command on each element of the text widget within the range. The command has three arguments appended to it before it is evaluated: the key, value, and index.
.TP
\fB\-image\fR
Include information about images in the dump results. This option is unsupported in Scintilla.
.TP
\fB\-indicator\fR
Include information about indicator transitions in the dump results. Indicator information is returned as indicatoron and indicatoroff elements that indicate the begin and end of each range of each indicator, respectively.
.TP
\fB\-mark\fR
Include information about marks in the dump results.
.TP
\fB\-style\fR
Include information about style transitions in the dump results. Style information is returned as styleon and styleoff elements that indicate the begin and end of each range of each style, respectively.
.TP
\fB\-tag\fR
Include information about tag transitions in the dump results. Tag information is returned as tagon and tagoff elements that indicate the begin and end of each range of each tag, respectively.
.TP
\fB\-text\fR
Include information about text in the dump results. The value is the text up to the next element or the end of range indicated by index2. A text element does not span newlines. A multi\-line block of text that contains no marks or tag transitions will still be dumped as a set of text segments that each end with a newline. The newline is part of the value.
.TP
\fB\-window\fR
Include information about embedded windows in the dump results. This option is unsupported in Scintilla.
.RE
.TP
\fIpathName \fBedit \fIoption ?arg arg ...?\fR
This command controls the undo mechanism and the modified flag. The exact behavior of the command depends on the option argument that follows the edit argument. The following forms of the command are currently supported:
.RS
.TP
\fIpathName \fBedit canredo\fR
Returns true if the redo stack is not empty.
.TP
\fIpathName \fBedit canundo\fR
Returns true if the undo stack is not empty.
.TP
\fIpathName \fBedit Imodified \fI?boolean?\fR
If boolean is not specified, returns the modified flag of the widget. The insert, delete, edit undo and edit redo commands or the user can set or clear the modified flag. If boolean is specified, sets the modified flag of the widget to boolean.
.TP
\fIpathName \fBedit redo\fR
When the \-undo option is true, reapplies the last undone edits provided no other edits were done since then. Generates an error when the redo stack is empty. Does nothing when the \-undo option is false.
.TP
\fIpathName \fBedit reset\fR
Clears the undo and redo stacks.
.TP
\fIpathName \fBedit separator\fR
Inserts a separator (boundary) on the undo stack. Does nothing when the \-undo option is false.
.TP
\fIpathName \fBedit undo\fR
Undoes the last edit action when the \-undo option is true. An edit action is defined as all the insert and delete commands that are recorded on the undo stack in between two separators. Generates an error when the undo stack is empty. Does nothing when the \-undo option is false.
.RE
.TP
\fIpathName \fBfold \fIcommand ?line?\fR
The fold command provides various capabilities related to Scintilla's folding functionality. Some operations are simple queries while others will impact the fold structure within the document. The following commands are supported:
.RS
.TP
\fBfoldall\fR
folds all lines within the document
.TP
\fBfoldbelow \fIline\fR
folds all lines which are after(below) line number line
.TP
\fBfoldparent \fIline\fR
returns the line containing the immediate fold parent of line
.TP
\fBfoldroot \fIline\fR
returns the line containing topmost fold parent of the specified line . This is at the top of the fold hierarchy containing line .
.TP
\fBisfolded \fIline\fR
return 1 if line contained in a folded parent, and 0 if it isn't
.TP
\fBshow \fIline\fR
fully expand the containing fold hierarchy such that line is visible
.TP
\fBtoggle \fIline\fR
toggle the fold state of line (ie if collapsed, expand it; if expanded, collapse it)
.TP
\fBtopunfolded \fIline\fR
return the line of the highest fold parent for line which is currently expanded
.TP
\fBunfoldall\fR
unfold all lines
.TP
\fBunfoldbelow \fIline\fR
unfold all lines which are after(below) line number line
.RE
.TP
\fIpathName \fBindex \fIindex ?\-textonly?\fR
Returns the position corresponding to index in the form line.char where line is the line number and char is the character number. See the documentation for the Tk Text widget for a description of the formats used to specify indices. NOTE: Specifying an X/Y location that corresponds to a line of annotation text will return the index for the end of the line associated with the annotation. If the \-textonly option is used, then an empty string is returned if the X/Y location is over an annotation.
.TP
\fIpathName \fBinsert \fIindex chars\fR
Inserts all of the chars argument just before the character at index. If index refers to the end of the text (the character after the last newline) then the new text is inserted just before the last newline instead.
.RE
.TP
\fIpathName \fBmargin \fIoption ?arg arg ...?\fR
This command is used to manage the widget's various margins (aka columns). The exact behavior of the command depends on the option argument that follows the margin argument. In most of the subcommands below, there is an argument which identifies the margin. It is labeled "marginID" in the following descriptions. The format of this argument can be any of the following: 1) the numeric index of the margin, where "0" is the leftmost margin, and "4" is rightmost, 2) the name of the margin, which will match the margin's type (eg "text", "symbol", etc), or 3) the alias name defined for the margin. The following forms of the command are currently supported:
.RS
.TP
\fIpathName \fBmargin bbox \fImarginID line\fR
Returns a list of four elements describing the screen area of the margin identified by marginID, at the line specified by line. The first two elements of the list give the x and y coordinates of the upper\-left corner of the area occupied by the character, and the last two elements give the width and height of the area. If the character is not visible on the screen then the return value is an empty list.
.TP
\fIpathName \fBmargin cget \fImarginID option\fR
This command returns the current value of the option named option associated with the margin given by marginID. Option may have any of the values accepted by the pathName margin configure widget command.
.TP
\fIpathName \fBmargin configure \fImarginID ?option? ?value? ?option value ...?\fR
This command is similar to the pathName configure widget command except that it modifies options associated with the margin given by marginID instead of modifying options for the overall text widget. If no option is specified, the command returns a list describing all of the available options for marginID. If option is specified with no value, then the command returns a list describing the one named option (this list will be identical to the corresponding sublist of the value returned if no option is specified). If one or more option\-value pairs are specified, then the command modifies the given option(s) to have the given value(s) in marginID; in this case the command returns an empty string.
.TP
\fIpathName \fBmargin count\fR
Returns the number of margins
.TP
\fIpathName \fBmargin dump \fImarginID ?option? Index1 ?Index2?\fR
Return the contents of the text widget from index1 up to, but not including index2, including the text and information about marks, tags, and embedded windows. If index2 is not specified, then it defaults to one character past index1. The information is returned in the following format::
key1 value1 index1 key2 value2 index2 ...
The possible key values are indicatoron, indicatoroff, text, mark, styleon, styleoff, tagon, and tagoff. The corresponding value is the indicator type, text, mark name, style number, or tag name. The index information is the index within the margin of the start of the indicator transition, style transition, text, mark, tag transition, image or window. One or more of the following switches (or abbreviations thereof) may be specified to control the dump:
.TP
\fB\-all\fR
Return information about all elements: indicator, style, text, marks, and tags. This is the default.
.TP
\fB\-command \fIcommand\fR
Instead of returning the information as the result of the dump operation, invoke the command on each element of the text widget within the range. The command has three arguments appended to it before it is evaluated: the key, value, and index.
.TP
\fB\-indicator\fR
Include information about indicator transitions in the dump results. Indicator information is returned as indicatoron and indicatoroff elements that indicate the begin and end of each range of each indicator, respectively.
.TP
\fB\-mark\fR
Include information about marks in the dump results.
.TP
\fB\-style\fR
Include information about style transitions in the dump results. Style information is returned as styleon and styleoff elements that indicate the begin and end of each range of each style, respectively.
.TP
\fB\-tag\fR
Include information about tag transitions in the dump results. Tag information is returned as tagon and tagoff elements that indicate the begin and end of each range of each tag, respectively.
.TP
\fB\-text\fR
Include information about text in the dump results. The value is the text up to the next element or the end of range indicated by index2. A text element does not span newlines. A multi\-line block of text that contains no marks or tag transitions will still be dumped as a set of text segments that each end with a newline. The newline is part of the value.
.TP
\fIpathName \fBmargin fillnumbers \fImarginID start count ?tagName {line ...}?\fR
This would be used to manually managing filling a margin with line numbers. This is really only used for cases when control over the appearance of the line numbers is needed. The fillnumbers command would be called within the \-linesaddedcommand callback function in a margin whose type was set to "lnums_alt". Setting the margin type to "lnums" would result in the Scintilla core code handling filling of the line numbers. The start option identifies where the line numbering should begin. The count option controls how many lines will be numbers. A value of <= 0 will number all lines from start until the end of the document. To apply custom styling to one or more line numbers, first configure a tag named tagName and then identify the list of line numbers as the argument following tagName. For example, to fill the line numbers from 1 to 10 where only the odd numbers are styled in red, first create a tag (ex: $sci tag config red \-margin \-fg red) and then execute $sci margin fillnumbers 1 10 red {1 3 5 7 9}.
.TP
\fIpathName \fBmargin hide \fImarginID\fR
Hides the margin specified by marginID. The margin's configuration information is maintained while hidden.
.TP
\fIpathName \fBmargin index \fI@X,Y\fR
Returns a list of three elements to identify the margin at the location indicated by the X and Y window location (where "@0,0" corresponds to the upperleft corner of the window). If a margin exists at the location, then the three values returned are: 1) the margin id, 2) the line number, and 3) the margin's alias (or an empty string if it an alias hasn't been defined). If the X/Y location isn't over a margin then an empty string is returned.
.TP
\fIpathName \fBmargin marker \fImarginID command markerName lines\fR
This command is used to add or remove the marker named markerName to the margin specified by marginID. The operation performed is controlled by the command argument, which would either be "add" or "clear". The lines option identifies which lines to add or remove the marker for. When removing, if the lines list is empty, then the specified marker would be removed from all lines. Also, when removing, if the markerName is set to "*", then all markers present for the specified lines would be removed.
.TP
\fIpathName \fBmargin marker \fImarginID list markerName ?line?\fR
This command returns a list of the lines containing the specified marker. If markerName is specified as "*" the line argument is required. When this done, the all markers present on the specified line will be returned.
.TP
\fIpathName \fBmargin names\fR
Returns information about each of the margins. Each margin is identified by a three element list containing the following: 1) the ID value of the margin (where "0" is the leftmost margin), 2) the type of the margin, and 3) the alias name, or an empty string if one hasn't been defined.
.TP
\fIpathName \fBmargin show \fImarginID\fR
Shows the margin specified by marginID. For margins that have not yet had a width set (ie their width is zero), the show operation will report an error unless the margin's type is set for linenumbers or the special fold margin. For those margins, the widget will automatically determine the appropriate width to use in order to allow the margin to be made visible.
.TP
\fIpathName \fBmargin tag \fI{line ...} ?tagName \-clear?\fR
This command will either add or remove a tag that was previously configured for use in the margin area (see here for more details). The margin tag will affect only text\-based margins (ie not those holding symbols). The tag named tagName will be added to the list of lines unless the \-clear option is specified, in which case the tag will be removed. When removing a tag, it can be removed from all lines by specifying an empty list for the lines. To remove all margin tags from all lines, the tagName option should not be specified (ie $sci margin tag {} \-clear).
.TP
\fIpathName \fBmargin text \fImarginID command arglist\fR
This command is used to manipulate the margin text within the margin specified by marginID. The margin specified by marginID must be of type text or rtext. The operation performed is controlled by the command argument, which would either be one of "clear", "get", or "set". If command is "clear", and there is no arglist, then the margin text for all lines in the document is removed. If arglist is provided, it is a list of one or more lines to clear. If the command argument is "get", the arglist must specify the line number of the margin text to return. If the command argument is "set", the arglist consists of a string value to set in the margin followed by one or more line numbers that should be modified.
.TP
\fIpathName \fBmargin visible \fImarginID\fR
Returns if the margin specified by marginID is currently being shown. This is different from checking if the margin's configuration value for the \-width option is zero, because when a margin is hidden its width value is retained so that it can be shown with the intended width.
.TP
\fIpathName \fBmargin width\fR
Return the total width in pixels of the visible margins.
.RE
.TP
\fIpathName \fBmark \fIoption ?arg arg ...?\fR
This command is used to manipulate marks. The exact behavior of the command depends on the option argument that follows the mark argument. The following forms of the command are currently supported:
.RS
.TP
\fIpathName \fBmark exists \fImarkName\fR
If markName exists, the command will return 1; otherwise 0 is returned.
.TP
\fIpathName \fBmark gravity \fImarkName ?direction?\fR
If direction is not specified, returns left or right to indicate which of its adjacent characters markName is attached to. If direction is specified, it must be left or right; the gravity of markName is set to the given value.
.TP
\fIpathName \fBmark names\fR
Returns a list whose elements are the names of all the marks that are currently set.
.TP
\fIpathName \fBmark next \fIindex\fR
Returns the name of the next mark at or after index. If index is specified in numerical form, then the search for the next mark begins at that index. If index is the name of a mark, then the search for the next mark begins immediately after that mark. This can still return a mark at the same position if there are multiple marks at the same index. These semantics mean that the mark next operation can be used to step through all the marks in a text widget. An empty string is returned if there are no marks after index.
.TP
\fIpathName \fBmark previous \fIindex\fR
Returns the name of the mark at or before index. If index is specified in numerical form, then the search for the previous mark begins with the character just before that index. If index is the name of a mark, then the search for the next mark begins immediately before that mark. This can still return a mark at the same position if there are multiple marks at the same index. These semantics mean that the mark previous operation can be used to step through all the marks in a text widget. An empty string is returned if there are no marks before index.
.TP
\fIpathName \fBmark set \fImarkName index\fR
Sets the mark named markName to a position just before the character at index. If markName already exists, it is moved from its old position; if it does not exist, a new mark is created. This command returns an empty string.
.TP
\fIpathName \fBmark unset \fImarkName ?markName ...?\fR
Remove the mark corresponding to each of the markName arguments. The removed marks will not be usable in indices and will not be returned by future calls to pathName mark names. This command returns an empty string.
.RE
.TP
\fIpathName \fBmarker \fI?option? ?arg arg ...?\fR
Markers are used to apply visual attributes to locations within one or more margins at specific line locations. The types of markers include simple shapes, like circles or arrows, as well as arbitrary images. For text\-based margins, the foreground and background colors can be specified. The following forms of the command are currently supported:
.RS
.TP
\fIpathName \fBmarker configure \fImarkerName ?option? ?value option value ...?\fR
This command is similar to the pathName configure widget command except that it modifies options associated with the marker given by markName instead of modifying options for the overall widget. If no option is specified, the command returns a list describing all of the available options for markerName. If option is specified with no value, then the command returns a list describing the one named option (this list will be identical to the corresponding sublist of the value returned if no option is specified). If one or more option\-value pairs are specified, then the command modifies the given option(s) to have the given value(s) in markerName; in this case the command returns an empty string.
.TP
\fIpathName \fBmarker delete \fImarkerName ?markerName ...?\fR
Deletes the named markers
.TP
\fIpathName \fBmarker exists \fImarkerName line\fR
Checks if the marker specified by markerName exists for line. Returns 1 if it does, 0 otherwise.
.TP
\fIpathName \fBmarker names\fR
Returns a sorted list of all currently defined markers (created by using the marker configure command).
.TP
\fIpathName \fBmarker types\fR
Returns the list of type names which can be used with the \-type option to the configure command.
.RE
.TP
\fIpathName \fBsearch \fI?switches? pattern index ?stopIndex?\fR
Searches the text in pathName starting at index for a range of characters that matches pattern. If a match is found, the index of the first character in the match is returned as result; otherwise an empty string is returned. One or more of the following switches (or abbreviations thereof) may be specified to control the search:
.RS
.TP
\fB\-forwards\fR
The search will proceed forward through the text, finding the first matching range starting at or after the position given by index. This is the default.
.TP
\fB\-backwards\fR
The search will proceed backward through the text, finding the matching range closest to index whose first character is before index (it is not allowed to be at index). Note that, for a variety of reasons, backwards searches can be substantially slower than forwards searches (particularly when using \-regexp), so it is recommended that performance\-critical code use forward searches.
.TP
\fB\-exact\fR
Use exact matching: the characters in the matching range must be identical to those in pattern. This is the default.
.TP
\fB\-regexp\fR
Treat pattern as a regular expression and match it against the text using the rules for regular expressions (see the regexp command for details). The default matching automatically passes both the \-lineanchor and \-linestop options to the regexp engine (unless \-nolinestop is used), so that ^$ match beginning and end of line, and ., [^ sequences will never match the newline character \n.
.TP
\fB\-nolinestop\fR
This allows . and [^ sequences to match the newline character \n, which they will otherwise not do (see the regexp command for details). This option is only meaningful if \-regexp is also given, and an error will be thrown otherwise. For example, to match the entire text, use pathName search \-nolinestop \-regexp ".*" 1.0.
.TP
\fB\-nocase\fR
Ignore case differences between the pattern and the text.
.TP
\fB\-count \fIvarName\fR
The argument following \-count gives the name of a variable; if a match is found, the number of index positions between beginning and end of the matching range will be stored in the variable. If there are no embedded images or windows in the matching range (and there are no elided characters if \-elide is not given), this is equivalent to the number of characters matched. In either case, the range matchIdx to matchIdx + $count chars will return the entire matched text.
.TP
\fB\-all\fR
Find all matches in the given range and return a list of the indices of the first character of each match. If a \-count varName switch is given, then varName is also set to a list containing one element for each successful match. Note that, even for exact searches, the elements of this list may be different, if there are embedded images, windows or hidden text. Searches with \-all behave very similarly to the Tcl command regexp \-all, in that overlapping matches are not normally returned. For example, applying an \-all search of the pattern \w+ against hello there will just match twice, once for each word, and matching Z[a\-z]+Z against ZooZooZoo will just match once.
.TP
\fB\-overlap\fR
When performing \-all searches, the normal behaviour is that matches which overlap an already\-found match will not be returned. This switch changes that behaviour so that all matches which are not totally enclosed within another match are returned. For example, applying an \-overlap search of the pattern \w+ against hello there will just match twice (i.e. no different to just \-all), but matching Z[a\-z]+Z against ZooZooZoo will now match twice. An error will be thrown if this switch is used without \-all.
.TP
\fB\-strictlimits\fR
When performing any search, the normal behaviour is that the start and stop limits are checked with respect to the start of the matching text. With the \-strictlimits flag, the entire matching range must lie inside the start and stop limits specified for the match to be valid.
.TP
\fB\-elide \fIcurrently not supported\fR
Find elided (hidden) text as well. By default only displayed text is searched.
.TP
\fB\-\-\fR
This switch has no effect except to terminate the list of switches: the next argument will be treated as pattern even if it starts with \-.
.RE
.PP
The matching range may be within a single line of text, or run across multiple lines (if parts of the pattern can match a new\-line). For regular expression matching one can use the various newline\-matching features such as $ to match the end of a line, ^ to match the beginning of a line, and to control whether . is allowed to match a new\-line. If stopIndex is specified, the search stops at that index: for forward searches, no match at or after stopIndex will be considered; for backward searches, no match earlier in the text than stopIndex will be considered. If stopIndex is omitted, the entire text will be searched: when the beginning or end of the text is reached, the search continues at the other end until the starting location is reached again; if stopIndex is specified, no wrap\-around will occur. This means that, for example, if the search is \-forwards but stopIndex is earlier in the text than startIndex, nothing will ever be found. See the Tk Text widget man page for more information.
.RE
.TP
\fIpathName \fBscisearch \fI?switches? pattern index ?stopIndex?\fR
Scintilla Search searches the text in pathName starting at index for a range of characters that matches pattern. If a match is found, the index of the first character in the match is returned as result; otherwise an empty string is returned. One or more of the following switches (or abbreviations thereof) may be specified to control the search:
.RS
.TP
\fB\-forwards\fR
The search will proceed forward through the text, finding the first matching range starting at or after the position given by index. This is the default.
.TP
\fB\-backwards\fR
The search will proceed backward through the text, finding the matching range closest to index whose first character is before index (it is not allowed to be at index).
.TP
\fB\-count \fIvarName\fR
The argument following \-count gives the name of a variable; if a match is found, the number of index positions between beginning and end of the matching range will be stored in the variable.
.TP
\fB\-exact\fR
Use exact matching: the characters in the matching range must be identical to those in pattern. This is the default.
.TP
\fB\-nocase\fR
Ignore case differences between the pattern and the text.
.TP
\fB\-regexp\fR
Treat pattern as a regular expression. In a regular expression, special characters interpreted are:
.RS
.TP 
\fB.\fR
Matches any character.
.TP 
\fB\\(\fR 
This marks the start of a region for tagging a match.
.TP 
\fB\\)\fR
This marks the end of a tagged region.
.TP
\fB\\n\fR 
Where n is 1 through 9 refers to the first through ninth tagged region when replacing. For example, if the search string was Fred\\([1-9]\\)XXX and the replace string was Sam\1YYY, when applied to Fred2XXX this would generate Sam2YYY. \0 refers to all of the matching text.
.TP
\fB\\<\fR
This matches the start of a word using Scintilla's definitions of words.
.TP
\fB\\>\fR
This matches the end of a word using Scintilla's definition of words.
.TP
\fB\\x\fR
This allows you to use a character x that would otherwise have a special meaning. For example, \\[ would be interpreted as [ and not as the start of a character set.
.TP
\fB[...]\fR
This indicates a set of characters, for example, [abc] means any of the characters a, b or c. You can also use ranges, for example [a\-z] for any lower case character.
.TP
\fB[^...]\fR
The complement of the characters in the set. For example, [^A\-Za\-z] means any character except an alphabetic character.
.TP
\fB^\fR
This matches the start of a line (unless used inside a set, see above).
.TP
\fB$\fR
This matches the end of a line.
.TP
\fB*\fR
This matches 0 or more times. For example, Sa*m matches Sm, Sam, Saam, Saaam and so on.
.TP
\fB+\fR
This matches 1 or more times. For example, Sa+m matches Sam, Saam, Saaam and so on.
.RE
Regular expressions will only match ranges within a single line, never matching over multiple lines.
.TP
\fB\-word\fR
A match only occurs if the characters before and after are not word characters.
.TP
\fB--\fR
This switch has no effect except to terminate the list of switches: the next argument will be treated as pattern even if it starts with \-.
.RE
The matching range must be within a single line of text. For regular expression matching one can use the various newline\-matching features such as $ to match the end of a line, ^ to match the beginning of a line. If stopIndex is specified, the search stops at that index: for forward searches, no match at or after stopIndex will be considered; for backward searches, no match earlier in the text than stopIndex will be considered. If stopIndex is omitted, the entire text will be searched.
.TP
\fIpathName \fBsee \fIindex ?\-center?\fR
Adjusts the view in the window so that the character given by index is completely visible. If index is already visible then the command does nothing. If index is a short distance out of view, the command adjusts the view just enough to make index visible at the edge of the window. If index is far out of view, then the command centers index in the window. The \-center option can be used to force index to be centered in the window.
.TP
\fIpathName \fBtag \fI?option? ?arg arg ...?\fR
A tag is a textual string that is associated with some of the characters in the widget. Tags may contain arbitrary characters, but it is probably best to avoid using the characters   (space), +, or \-: these characters have special meaning in indices, so tags containing them cannot be used as indices. There may be any number of tags associated with characters in a text. Each tag may refer to a single character, a range of characters, or several ranges of characters. An individual character may have any number of tags associated with it. The order that overlapping tags are displayed is controlled by the logical identifier associated with each of the tag types below(higher ID numbers are drawn last). See the table below for descriptions of the supported types. The following forms of the command are currently supported:
.RS
.TP
\fIpathName \fBtag add \fItagName index1 ?index2?\fR
Associate the tag tagName (one will be created if it doesn't already exist) with all of the characters starting with index1 and ending just before index2 (the character at index2 is not tagged). If index2 is omitted then the single character at index1 is tagged. If there are no characters in the specified range (e.g. index1 is past the end of the file or index2 is less than or equal to index1) then the command has no effect. EXCEPTION: If tagName is the predefined selection tag (i.e. "sel"), then specifying index2 to be less than index1 will have the effect of positioning the insertion point at the start of the selection.
.TP
\fIpathName \fBtag bind \fItagName ?sequence? ?script?\fR
This command associates script with the tag given by tagName. Whenever the event sequence given by sequence occurs for a character that has been tagged with tagName, the script will be invoked. This widget command is similar to the bind command except that it operates on characters in a text rather than entire widgets. See the bind manual entry for complete details on the syntax of sequence and the substitutions performed on script before invoking it. If all arguments are specified then a new binding is created, replacing any existing binding for the same sequence and tagName (if the first character of script is + then script augments an existing binding rather than replacing it). In this case the return value is an empty string. If script is omitted then the command returns the script associated with tagName and sequence (an error occurs if there is no such binding). If both script and sequence are omitted then the command returns a list of all the sequences for which bindings have been defined for tagName. The only events for which bindings may be specified are those related to the mouse and keyboard (such as Enter, Leave, ButtonPress, Motion, and KeyPress) or virtual events. Event bindings for a text widget use the current mark. An Enter event triggers for a tag when the tag first becomes present on the current character, and a Leave event triggers for a tag when it ceases to be present on the current character. Enter and Leave events can happen either because the current mark moved or because the character at that position changed. Note that these events are different than Enter and Leave events for windows. Mouse and keyboard events are directed to the current character. If a virtual event is used in a binding, that binding can trigger only if the virtual event is defined by an underlying mouse\-related or keyboard\-related event.
.TP
\fIpathName \fBtag cget \fItagName option\fR
This command returns the current value of the option named option associated with the tag given by tagName. Option may have any of the values accepted by the pathName tag configure widget command.
.TP
\fIpathName \fBtag configure \fItagName ?\-margin? ?option? ?value? ?option value ...?\fR
This command is similar to the pathName configure widget command except that it modifies options associated with the tag given by tagName instead of modifying options for the overall text widget. If no option is specified, the command returns a list describing all of the available options for tagName. If option is specified with no value, then the command returns a list describing the one named option (this list will be identical to the corresponding sublist of the value returned if no option is specified). If one or more option\-value pairs are specified, then the command modifies the given option(s) to have the given value(s) in tagName; in this case the command returns an empty string. Note, the special \-margin option, if used, must immediately follow tagName. It is used to create and configure tags used within the margin area. See "configure options" for more details
.TP
\fIpathName \fBtag delete \fItagName ?tagName ...?\fR
Deletes all tag information for each of the tagName arguments. The command removes the tags from all characters in the file and also deletes any other information associated with the tags, such as bindings and display information. The command returns an empty string.
.TP
\fIpathName \fBtag lower \fItagName\fR
This has NOT BEEN IMPLEMENTED because Scintilla core functionality regarding "markers" (which is how the ScintillaTk tag functionality has been implemented) does not support drawing priority for markers that overlap.
.TP
\fIpathName \fBtag names \fI?index?\fR
Returns a list whose elements are the names of all the tags that are active at the character position given by index. If index is omitted, then the return value will describe all of the tags that exist for the widget.
.TP
\fIpathName \fBtag nextrange \fItagName index1 ?index2?\fR
This command searches the text for a range of characters tagged with tagName where the first character of the range is no earlier than the character at index1 and no later than the character just before index2 (a range starting at index2 will not be considered). The command's return value is a list containing two elements, which are the index of the first character of the range and the index of the character just after the last one in the range. If no matching range is found then the return value is an empty string. If index2 is not given then it defaults to the end of the text.
.TP
\fIpathName \fBtag prevrange \fItagName index1 ?index2?\fR
This command searches the text for a range of characters tagged with tagName where the first character of the range is before the character at index1 and no earlier than the character at index2 (a range starting at index2 will be considered). The command's return value is a list containing two elements, which are the index of the first character of the range and the index of the character just after the last one in the range. If no matching range is found then the return value is an empty string. If index2 is not given then it defaults to the beginning of the text.
.TP
\fIpathName \fBtag raise \fItagName\fR
This has NOT BEEN IMPLEMENTED because Scintilla core functionality regarding "markers" (which is how the ScintillaTk tag functionality has been implemented) does not support drawing priority for markers that overlap.
.TP
\fIpathName \fBtag ranges \fItagName\fR
Returns a list describing all of the ranges of text that have been tagged with tagName. The first two elements of the list describe the first tagged range in the text, the next two elements describe the second range, and so on. The first element of each pair contains the index of the first character of the range, and the second element of the pair contains the index of the character just after the last one in the range. If there are no characters tagged with tag then an empty string is returned.
.TP
\fIpathName \fBtag remove \fItagName index1 ?index2 index1 index2 ...?\fR
Remove the tag tagName from all of the characters starting at index1 and ending just before index2 (the character at index2 is not affected). A single command may contain any number of index1\-index2 pairs. If the last index2 is omitted then the tag is removed from the single character at index1. If there are no characters in the specified range (e.g. index1 is past the end of the file or index2 is less than or equal to index1) then the command has no effect. This command returns an empty string.
.RE
\fBTag Types\fR
.TS
box;
lfB lfB lfB
l np1 ap9.
Type	ID	Description
plain	0	Underlined with a single, straight line.
squiggle	1	A squiggly underline, 3 pixels in height
tt	2	A line of small "T" shapes
diagonal	3	Diagonal hatching
strike	4	A solid "strike through" line draw at the vertical mid\-point
hidden	5	No visual effect
box	6	A rectangular box around the text
roundbox	7	T{
A rectangle with rounded corners around the text, 
using translucent drawing for the interior 
(NOT SUPPORTED YET)
T}
squarebox	8	T{
A rectangle around the text, using translucent 
drawing for the interior 
(NOT SUPPORTED YET)
T}
dash	9	A dashed underline
dots	10	A dotted underline
squigglelow	11	Similar to squiggle but only 2 pixels in height
dotbox	12	T{
A dotted rectangle around the text, using translucent 
drawing for the interior 
(NOT SUPPORTED YET)
T}
.TE
.PP
.PP
For the above types, use the \-foreground configuration option for the tag to control the color. For types that use a filled interior, use the \-background option to set the interior color. The following lists the supported configuration options, though not all are supported for each type of tag (exceptions are noted):
.TP
\fB\-background|\-bg \fIcolor\fR
Color specifies the color used for tags that have a filled interior.
.TP
\fB\-bold \fIboolean \fR(ONLY FOR MARGIN TAGS)
Specifies if margins showing text will use a bold font
.TP
\fB\-foreground|\-fg \fIcolor\fR
Color specifies the color used for tags, and for tags will filled interiors color is for the outline.
.TP
\fB\-indicatortype \fItype \fR(NOT FOR MARGIN TAGS)
The type value matches the names in the above table
.TP
\fB\-italic \fIboolean \fR(ONLY FOR MARGIN TAGS)
Specifies if margins showing text will use an italicized font
There is a special tag used to control the appearance (foreground and background colors only) of the widget's selection. The name of this tag is sel, and it cannot be deleted.
.TP
\fIpathName \fBversion\fR
Returns a 3\-element list containing information identifying the current version of the widget. The fields of the list are:\fR
version : identifies the Tcl package version
date : the date the package was created
core_rls: this identifies the release of the Scintilla core widget
.PP
.SH "KNOWN BUGS"
Patterns including newline (\n) may not work correctly in all cases. This limitation is due to how Scintilla stores document text; the end of line characters are stripped from the document making the search challenging.
.PP
The pathName search \-regexp sub\-command attempts to perform sophisticated regexp matching across multiple lines in an efficient fashion. Under certain conditions the search result might differ from that obtained by applying the same regexp to the entire text from the widget in one go.
.PP
Whenever one possible match is fully enclosed in another, the search command will attempt to ensure only the larger match is returned. When performing backwards regexp searches it is possible that Tcl will not always achieve this.
.RE
.RE


'\" Local Variables:
'\" mode: nroff
'\" fill-column: 78
'\" End:
